PLaSK library

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType > Struct Template Reference

Base class for element meshes with common code for 2D and 3D. More...

`#include <plask/mesh/rectangular_masked_common.hpp>`

Inheritance diagram for plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >:
[legend]
Collaboration diagram for plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >:
[legend]

## Classes
class | const_iterator
| Iterator over elements. More...

## Public Types
using | Element = typename MaskedMeshType::Element
typedef const_iterator | iterator
| Iterator over elements. The same as const_iterator, since non-const iterators are not supported.
Public Types inherited from plask::MeshD< DIM >
enum |
| Number of dimensions. More...
typedef Primitive< DIM >::DVec | LocalCoords
| Type of vector representing coordinates in local space.
typedef IndexedIterator< const MeshD< dimension >, LocalCoords > | const_iterator
| Random access iterator type which allow iterate over all points in this mesh, in order appointed by operator[].
typedef const_iterator | iterator
typedef const_iterator | Iterator

## Public Member Functions
const_iterator | begin () const
const_iterator | end () const
| ElementMeshBase (const MaskedMeshType *originalMesh)
| ElementMeshBase (const MaskedMeshType &originalMesh)
std::size_t | size () const override
| Get number of elements.
LocalCoords | at (std::size_t index) const override
| Get point with given mesh index.
bool | empty () const override
Public Member Functions inherited from plask::MeshD< DIM >
LocalCoords | operator[] (std::size_t index) const
| Get point with given mesh index.
const_iterator | begin () const
const_iterator | end () const
| MeshD (const MeshD &PLASK_UNUSED(to_copy))
| Initialize this to be the same as `to_copy` but don't copy any changes observer.
| MeshD ()
MeshD & | operator= (const MeshD &PLASK_UNUSED(to_copy))
| Set this to be the same as `to_copy` but doesn't changed changes observer.
bool | operator== (const MeshD &to_compare) const
| Check if this mesh and `to_compare` represent the same sequence of points (have exactly the same points in the same order).
bool | operator!= (const MeshD &to_compare) const
| Check if this mesh and `to_compare` represent different sequences of points.
void | print (std::ostream &out) const override
| Print this to stream `out`.
Public Member Functions inherited from plask::Mesh
template<typename ClassT , typename methodT >
boost::signals2::connection | changedConnectMethod (ClassT *obj, methodT method, boost::signals2::connect_position at=boost::signals2::at_back)
| Connect a method to changed signal.
template<typename ClassT , typename methodT >
void | changedDisconnectMethod (ClassT *obj, methodT method)
template<typename EventT = Event, typename ... Args>
void | fireChanged (Args &&... event_constructor_params_without_source)
| Call changed with this as event source.
void | fireResized ()
| This method is called when the mesh is resized.
virtual void | writeXML (XMLElement &object) const
| Write mesh to XML.
virtual | ~Mesh ()
Public Member Functions inherited from plask::Printable
virtual | ~Printable ()
std::string | str () const
| Get string representation of this using print method.
Public Member Functions inherited from plask::MeshBase
virtual | ~MeshBase ()

## Public Attributes
const MaskedMeshType * | originalMesh
RectangularMesh< DIM > | fullMesh
Public Attributes inherited from plask::Mesh
boost::signals2::signal< void(Event &)> | changed
| Changed signal, fired when mesh was changed.

## Additional Inherited Members
Protected Member Functions inherited from plask::MeshD< DIM >
virtual bool | hasSameNodes (const MeshD< dimension > &to_compare) const
| Check if this mesh and `to_compare` represent the same sequence of points (have exactly the same points in the same order).
Protected Member Functions inherited from plask::Mesh
virtual void | onChange (const Event &evt)
| This method is called when the mesh is changed, just before changed signal.

## Detailed Description

template<int DIM>
template<typename MaskedMeshType>
struct plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >

Base class for element meshes with common code for 2D and 3D.

Definition at line 154 of file rectangular_masked_common.hpp.

## Member Typedef Documentation

## ◆ Element

template<int DIM>
template<typename MaskedMeshType >

using plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >::Element = typename MaskedMeshType::Element

Definition at line 156 of file rectangular_masked_common.hpp.

## ◆ iterator

template<int DIM>
template<typename MaskedMeshType >

typedef const_iterator plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >::iterator

Iterator over elements. The same as const_iterator, since non-const iterators are not supported.

Definition at line 179 of file rectangular_masked_common.hpp.

## Constructor & Destructor Documentation

## ◆ ElementMeshBase() [1/2]

template<int DIM>
template<typename MaskedMeshType >

plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >::ElementMeshBase | ( | const MaskedMeshType * | originalMesh | ) |
| inline explicit

Definition at line 190 of file rectangular_masked_common.hpp.

## ◆ ElementMeshBase() [2/2]

template<int DIM>
template<typename MaskedMeshType >

plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >::ElementMeshBase | ( | const MaskedMeshType & | originalMesh | ) |
| inline explicit

Definition at line 193 of file rectangular_masked_common.hpp.

## Member Function Documentation

## ◆ at()

template<int DIM>
template<typename MaskedMeshType >

LocalCoords plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >::at | ( | std::size_t | index | ) | const
| inline override virtual

Get point with given mesh index.

Parameters

  index | index of point, from 0 to size()-1

Returns
  point with given `index`

Implements plask::MeshD< DIM >.

Definition at line 201 of file rectangular_masked_common.hpp.

## ◆ begin()

template<int DIM>
template<typename MaskedMeshType >

const_iterator plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >::begin | ( |  | ) | const
| inline

Returns
  iterator referring to the first element

Definition at line 182 of file rectangular_masked_common.hpp.

## ◆ empty()

template<int DIM>
template<typename MaskedMeshType >

bool plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >::empty | ( |  | ) | const
| inline override virtual

Returns
  `true` only if mesh is empty (there are no points in mesh)

Reimplemented from plask::Mesh.

Definition at line 205 of file rectangular_masked_common.hpp.

## ◆ end()

template<int DIM>
template<typename MaskedMeshType >

const_iterator plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >::end | ( |  | ) | const
| inline

Returns
  iterator referring to the past-the-end element

Definition at line 185 of file rectangular_masked_common.hpp.

## ◆ size()

template<int DIM>
template<typename MaskedMeshType >

std::size_t plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >::size | ( |  | ) | const
| inline override virtual

Get number of elements.

Returns
  number of elements

Implements plask::Mesh.

Definition at line 199 of file rectangular_masked_common.hpp.

## Member Data Documentation

## ◆ fullMesh

template<int DIM>
template<typename MaskedMeshType >

RectangularMesh<DIM> plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >::fullMesh

Definition at line 188 of file rectangular_masked_common.hpp.

## ◆ originalMesh

template<int DIM>
template<typename MaskedMeshType >

const MaskedMeshType* plask::RectangularMaskedMeshBase< DIM >::ElementMeshBase< MaskedMeshType >::originalMesh

Definition at line 187 of file rectangular_masked_common.hpp.

The documentation for this struct was generated from the following file:

- plask/mesh/rectangular_masked_common.hpp